#include <windows.h>
#include "gpioLib.h"
#include "CoProcLib.h"
#include "characterlcd.h"

int wmain(void)
{
    DWORD procID = 0;
    DWORD versionMajor = 0;
    DWORD versionMinor = 0;
    DWORD versionBuild = 0;

    GPIOGetLibVersion(&versionMajor, &versionMinor, &versionBuild);    ///< Get GPIO library version
    printf("GPIOLib Version %d.%d.%d, ", versionMajor, versionMinor, versionBuild);
    procID = getPROCID();                                              ///< Get processor ID
    switch(procID)
    {
        case TYPE_PXA270:
            printf("PXA270 detected\n");
            break;
        case TYPE_PXA320:
            printf("PXA320 detected\n");
            break; 
        case TYPE_PXA300:
            printf("PXA300 detected\n");
            break; 
        case TYPE_PXA310:
            printf("PXA310 detected\n");
            break; 
        case TYPE_TEGRA2:
            printf("Tegra 2 detected\n");
            break;
        case TYPE_TEGRA3:
            printf("Tegra 3 detected\n");
            break; 
        default:
            printf("Processor type unknown\n");
            return FALSE;
            break;
    }

    InitGPIOLib();                                                  ///< Initializes GPIO library
    InitLcdPins();                                                  ///< Pin configuration for LCD
    InitLcd();                                                      ///< Initializes the LCD
    PutStringOnLcd(LINE_1, 0, "      Toradex    ", 20);             ///< Display string on LCD
    PutStringOnLcd(LINE_2, 0, "       20x4      ", 20);
    PutStringOnLcd(LINE_3, 0, "Character LCD demo  ", 20);
    PutStringOnLcd(LINE_4, 0, "for Toradex Modules ", 20);
    SendByteToLcd(0x00, COMMAND);
    Sleep(100);
    DeInitGPIOLib();                                                ///< De-initialize GPIO library
    return TRUE;
}